\name{MesOp-class}
\Rdversion{1.1}
\docType{class}
\alias{MesOp}
\title{Class \code{"MesOp"}}
\description{
  Class \code{MesOp} implements the steepest gradient descent method in the space
  of measures, provides printing and plotting routines for the class objects.
}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("MesOp", number.of.steps, space, measure, object.function, gradient.function)}.
%%  ~~ describe objects here ~~ 
}
\section{Slots}{
  \describe{
    \item{\code{space}:}{Object of class \code{"vector"}, finite grid on which \code{measure} is defined.}
    \item{\code{measure}:}{Object of class \code{"vector"}, over which \code{object.function} is optimized.}
    \item{\code{object.function}:}{Object of class \code{"function"}, function to be optimized, must
      have a signature \code{value <- object.function(measure, space, ...)}.}
    \item{\code{gradient.function}:}{Object of class \code{"function"}, gradient of the \code{object.function},
      must have a signature \code{gradient.vector <- gradient.function(measure, space, ...)}.}
    \item{\code{minim}:}{Object of class \code{"logical"}, if \bold{TRUE} the function is minimized and it is maximized otherwise.}
    \item{\code{smallest.step.size}:}{Object of class \code{"numeric"}, gradient descent terminates if the
      current step size is smaller than \code{smallest.step.size}.}
    %% \item{\code{step.algo}:}{Object of class \code{"numeric"}, algorithm for choosing the step size, 0 - line
    %%  search algorithm, 1 - Armijo algorithm.}
    \item{\code{tolerance.measure}:}{Object of class \code{"numeric"}, zero-value threshold parameter for
      discarding atoms of a negligible size.}
    \item{\code{tolerance.gradient}:}{Object of class \code{"numeric"}, threshold parameter to decide when the
      coordinates of the gradient vector are sufficiently small.}
    \item{\code{uni}:}{Object of class \code{"logical"}, if \bold{TRUE} then we spread the mass uniformly among the
      points where the gradient is minimal.}
    \item{\code{details}:}{Object of class \code{"logical"}, if \bold{TRUE} prints extra information
      on progress.}
    \item{\code{visualize}:}{Object of class \code{"logical"}, if \bold{TRUE} plots extra information
      on progress.}
    %% \item{\code{alpha}:}{Object of class \code{"numeric"} ~~ }
    %% \item{\code{base}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{step.size}:}{Object of class \code{"numeric"}, size of the step to be performed in the direction
      of the gradient/anti-gradient.}
    \item{\code{too.small.step.size}:}{Object of class \code{"logical"},
     gradient descent terminates if the
      current step size is smaller than \code{smallest.step.size}.}
  }
}
\section{Methods}{
  \describe{
    \item{GoSteep}{\code{signature(object = "MesOp")}: Implementation of
      the steepest descent method in the space of measures. }
    \item{plot}{\code{signature(x = "MesOp")}: Plot an object of class MesOp. }
    \item{print}{\code{signature(x = "MesOp")}: Print an object of class MesOp. }
    \item{summary}{\code{signature(object = "MesOp")}: Summary information on an object of class mesop. }}
}
%% \references{
%%  ~~put references to the literature/web site here~~
%% }
\author{Alexey Lindo, email: \email{lindo@chalmers.se} \cr
  Sergei Zuyev, email: \email{sergei.zuyev@chalmers.se}.
}

%% \note{
%%  ~~further notes~~
%%}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{\code{\link{GoSteep}}, \code{\link{plot}} and
  \code{\link{summary}}}

\examples{
showClass("MesOp")
}
\keyword{class, optimization}
